{% extends 'en/en_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <h3 class="h3 c-blue mb-5">
                    Edit Report Data
                </h3>
                <form action="{% url 'backend:report_edit' observation.pk %}" method="post"
                      enctype="multipart/form-data">
                    <div class="row g-3">
                        <div class="row mb-4 g-3">
                            <div class="h5 c-blue">Elasmobranch Information</div>
                            <div class="col-md-12">
                                <label for="datetime" class="form-label">Date and Time of Encounter <span
                                        class="c-red">*</span></label>
                                <input type="datetime-local" class="form-control" name="datetime"
                                       id="datetime"
                                       value="{{ observation.datetime|date:'Y-m-d' }}T{{ observation.datetime|time:'H:i:s' }}"
                                       required>
                            </div>
                            <div class="col-md-6">
                                <label for="location" class="form-label">
                                    Location of Encounter <span class="c-red">*</span>
                                </label>
                                <input type="text" class="form-control" name="location"
                                       id="location" value="{{ observation.location }}" required>
                            </div>
                            <div class="col-md-6">
                                <label for="province" class="form-label">
                                    Province <span class="c-red">*</span>
                                </label>
                                <select class="form-select" name="province" id="province" required>

                                </select>
                            </div>
                            <div class="col-md-6">
                                <label for="latitude" class="form-label">
                                    Latitude
                                </label>
                                <input type="text" class="form-control" name="latitude"
                                       id="latitude" value="{{ observation.latitude|default:0 }}">
                                <label for="longitude" class="form-label mt-2">
                                    Longitude
                                </label>
                                <input type="text" class="form-control" name="longitude"
                                       id="longitude" value="{{ observation.longitude|default:0 }}">
                                <hr/>
                                {% if observation.type == 'sighting' %}
                                    <label for="depth" class="form-label mt-2">
                                        Depth <span class="c-red">*</span>
                                    </label>
                                    <div class="input-group">
                                        <input type="text" class="form-control" name="depth"
                                               id="depth" value="{{ observation.depth|default:0 }}" required>
                                        <span class="input-group-text">meter</span>
                                    </div>
                                {% endif %}
                            </div>
                            <div class="col-md-6">
                                <div class="map" id="map"></div>
                            </div>
                            <div class="col-md-12">
                                <label for="formFileMultiple" class="form-label">
                                    Upload Photo
                                </label>
                                <input class="form-control" type="file" accept=".png, .jpg, .jpeg" onchange="checkFileSize(this)" name="upload" id="formFileMultiple"
                                       multiple>
                                <small id="imageHelp" class="form-text text-muted">Max size: 2.5MB, allowed extensions: .png, .jpg, .jpeg</small>
                            </div>
                        </div>
                        <div class="row g-3">
                            <div class="h5 c-blue">Additional Information</div>
                            <div class="col-md-12">
                                <label for="common_name" class="form-label">
                                    Common Name
                                </label>
                                <input type="text" class="form-control" name="common_name"
                                       id="common_name" value="{{ observation.common_name|default:"Unidentified" }}">
                            </div>
                            <div class="col-md-12">
                                <label for="scientific_name" class="form-label">
                                    Scientific Name
                                </label>
                                <input type="text" class="form-control" name="scientific_name"
                                       id="scientific_name" value="{{ observation.scientific_name }}">
                            </div>
                            {% if observation.type == 'landing' %}
                                <div class="col-md-12">
                                    <label for="capture_method" class="form-label">
                                        Capture Method
                                    </label>
                                    <input type="text" class="form-control" name="capture_method"
                                           id="capture_method" value="{{ observation.capture_method }}">
                                </div>
                            {% endif %}
                            <div class="col-md-6">
                                <label for="weight" class="form-label">
                                    Weight
                                </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" name="weight"
                                           id="weight" value="{{ observation.weight|default:0 }}">
                                    <span class="input-group-text">kg</span>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <label for="length" class="form-label">
                                    Length
                                </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" name="length"
                                           id="length" value="{{ observation.length|default:0 }}">
                                    <span class="input-group-text">meter</span>
                                </div>
                            </div>
                            <div class="{% if observation.type == 'sighting' %} col-md-6 {% else %} col-md-12 {% endif %}">
                                <label for="sex" class="form-label">
                                    Sex
                                </label>
                                <div class="form-check">
                                    <input class="form-check-input" type="radio" name="sex"
                                           value="male" {% if observation.sex == 'male' %}checked{% endif %}>
                                    <label class="form-check-label" for="sex">Male</label>
                                </div>
                                <div class="form-check">
                                    <input class="form-check-input" type="radio" name="sex"
                                           value="female" {% if observation.sex == 'female' %}checked{% endif %}>
                                    <label class="form-check-label" for="sex">Female</label>
                                </div>
                                <div class="form-check">
                                    <input class="form-check-input" type="radio" name="sex"
                                           value="unidentified"
                                           {% if observation.sex == 'unidentified' %}checked{% endif %}>
                                    <label class="form-check-label" for="sex">Unidentified</label>
                                </div>
                            </div>
                            {% if observation.type == 'sighting' %}
                                <div class="col-md-6">
                                    <label for="habitat" class="form-label">
                                        Habitat at Sight
                                    </label>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="sand"
                                               {% if 'sand' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Sand</label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="mud"
                                               {% if 'mud' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Mud</label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="coralReef"
                                               {% if 'coralReef' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Coral Reef</label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="openWater"
                                               {% if 'openWater' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Open Water</label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="seagrassBed"
                                               {% if 'seagrassBed' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Seagrass Bed</label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="habitat"
                                               value="mangrove"
                                               {% if 'mangrove' in observation.habitat %}checked{% endif %}>
                                        <label class="form-check-label" for="habitat">Mangrove</label>
                                    </div>
                                </div>
                            {% endif %}
                            <div class="col-md-12">
                                <label for="description" class="form-label">
                                    Encounter Description
                                </label>
                                <textarea name="description" class="form-control" rows="3">{{ observation.description }}</textarea>
                            </div>
                            <div class="col-md-12">
                                <label for="action" class="form-label">
                                    What were you doing when you saw the Elasmobranch?
                                </label>
                                <textarea name="action" class="form-control" rows="3">{{ observation.action }}</textarea>
                            </div>
                            <div class="col-md-12">
                                <label for="activity" class="form-label">
                                    How often are you in the area where you saw the Elasmobranch?
                                </label>
                                <textarea name="activity" class="form-control" rows="3">{{ observation.activity }}</textarea>
                            </div>
                        </div>
                        <div class="text-center my-5">
                            <button type="submit" class="btn btn-success">
                                <i class="bi bi-check"></i> Save
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script>
        function checkFileSize(input) {
            var maxSize = 2.5 * 1024 * 1024; // 2.5 MB dalam bytes
            if (input.files.length > 0) {
                var fileSize = input.files[0].size;
                if (fileSize > maxSize) {
                    alert('File size is too large.')
                    input.value = '';
                }
            }
        }
    </script>
    <script>
        $(document).ready(function () {
            let province = $(`#province`);
            $.each(provinces, function (index, item) {
                let selectedProvince = item.name === '{{ observation.province|safe }}';
                province.append(new Option(item.name, item.name, false, selectedProvince));
            });

            let latitude = $(`#latitude`);
            let longitude = $(`#longitude`);

            let latlng = L.latLng({{ observation.latitude|safe }}, {{ observation.longitude|safe }});
            const zoomLevel = 7;

            let map = L.map(`map`, {
                center: latlng,
                zoom: zoomLevel
            });

            let oceanBaseMap = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
                maxZoom: 18,
                attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Points &copy 2012 LINZ'
            });

            oceanBaseMap.addTo(map);

            let mapMarker = new L.Marker(latlng, {draggable: 'true'});

            mapMarker.on('dragend', function (event) {
                let marker = event.target;
                let position = marker.getLatLng();
                mapMarker.setLatLng(new L.LatLng(position.lat, position.lng), {draggable: 'true'});
                map.panTo(new L.LatLng(position.lat, position.lng));
                latitude.val(position.lat);
                longitude.val(position.lng);
            });

            map.addLayer(mapMarker);
            
            latitude.change(function () {
                let position = mapMarker.getLatLng();
                mapMarker.setLatLng(new L.LatLng($(this).val(), position.lng), {draggable: 'true'});
                map.panTo(new L.LatLng($(this).val(), position.lng))
            })

            longitude.change(function () {
                let position = mapMarker.getLatLng();
                mapMarker.setLatLng(new L.LatLng(position.lat, $(this).val()), {draggable: 'true'});
                map.panTo(new L.LatLng(position.lat, $(this).val()))
            })

            function onMapClick(e) {
                if (!mapMarker) {
                    mapMarker = new L.Marker(e.latlng, {draggable: 'true'});
                    latitude.val(e.latlng.lat)
                    longitude.val(e.latlng.lng);

                    mapMarker.on('dragend', function (event) {
                        let marker = event.target;
                        let position = marker.getLatLng();
                        mapMarker.setLatLng(new L.LatLng(position.lat, position.lng), {draggable: 'true'});
                        map.panTo(new L.LatLng(position.lat, position.lng));
                        latitude.val(position.lat);
                        longitude.val(position.lng);
                    });
                    map.addLayer(mapMarker);
                }
            }

            map.on('click', onMapClick);
        });
    </script>
{% endblock %}